local 
N, H, S, D, E, F, DE, SA, T, None = "N", "H", "S", "D", "E", "F", "DE", "SA", "T", "None"

local TH = "TH"

STATES = {
    N = 2,
    E = 5,
    D = 3,
    H = 2
}

local StateMachine = class:extend("StateMachine")
local theFunc

function StateMachine:__init__(kwargs)
    self._observations = {
        SL = {N,H,S,None},
        C = {N,H,S,D,E,F,DE,SA,T,None},
        A = {N,H,S,D,E,F,DE,SA,T,None},
        P = {D,E,F,DE,SA,T,None},
        PN = {N,D,E,F,DE,SA,T,None},
    }
    
    self.stateTransitionTable = stateTransitionTable
    self.map = kwargs.map or {}
    self._info = self.map.observations
    self.peform = self.peformStateMachine
end

function converge()
    convergeto = true
    for x, i in pairs(game.map.entities) do
        if i.isBot then
            i.boid.path = nil
        end
    end
end

function StateMachine:peformStateMachine(obj)
    local p = function()
    obj:cry("peforming")
    local acted = nil
    
    local sm = self.stateTransitionTable
    local cs = self:currentState(obj)
    local obs = sm[cs].obs--self:observation(obj)
    
    log("orbserving yes ")
    obj.oldTarget = obj.oldTarget or obj.target
    obj.oldFoodTarget = obj.oldFoodTarget or obj.foodTarget
    local o = obj.oldTarget
    local of = obj.oldFoodTarget
    local i = self:observe(obj,obs)--sm[cs][obs])
    log("observed "..i)
    if obj.target then
        obj.oldTarget = nil
    end
    if obj.foodTarget then
        obj.oldFoodTarget = nil
    end
    
    -- todo???? make random
    if obj.target ~= o and o and obj.target and not o:isDead() and not o.isPlayer then
        local dis1 = lume.distance(obj.x, obj.y, obj.target.x, obj.target.y)/tw
        local dis2 = lume.distance(obj.x, obj.y, o.x, o.y)/tw
        if dis2 < (dis1+(o.isPayer and 3 or 10)) then
            obj.target = o
        end
    end
    
    if obj.foodTarget ~= of and of and obj.foodTarget and not of:isDead() and not of.isPlayer then
        local dis1 = lume.distance(obj.x, obj.y, obj.foodTarget.x, obj.foodTarget.y)/tw
        local dis2 = lume.distance(obj.x, obj.y, of.x, of.y)/tw
        if dis2 < (dis1+(of.isPayer and 3 or 10)) or (of.isItem and obj.foodTarget.isCreature) then
            obj.foodTarget = of
            i = i == TH and i or "H"
        end
    end
    
    if convergeto then
        i = "E"
        obj.target = toybox.room.player
        error("Double check")
    end
    
    --if i~=None then warn("not None action!") end
    
    shifted = nil
    --get probability to shift to next state
    probShift = self:getProbShift(sm[cs][i])
    if math.random()<probShift and (not obj.noChangeState or i==TH) then
        cs = sm[cs][i].state or sm[cs][i][1] or "Curious" or cs
        shifted = true
        log("shifted to "..cs)
    end
    
    obj.currentState = cs
    if true then--obj.target ~= toybox.room.play9er then
        obj:cry("_________"..cs.." as "..i)
    end
    
    if sm[cs].action ~= nil then
        log("AI "..sm[cs].action)
        self:doStatelessAI(sm[cs].action,obj,obj.target)
        acted = true --??
    else
        obj.done = true
        warn("No action for "..cs)
    end
    if convergeto then
        obj:moveTo(toybox.room.player)
    end
    end
    
    if obj.isSeen then
        obj.room:startCoroutine(p)
    else
        p()
    end

end

function StateMachine:currentState(obj)
    return obj.currentState or (obj.stats and obj.stats.currentState)
end

--Inputs and meaning:
---N(Noise Detected)
---H(User Hungry)
---S(Strange Smell Detected)
---D(Dead Comrade Detected)
---E(Alive Enemy Seen)
---F(Friend Seen)
---DE(Dead Enemy Seen)
---SA(User Satisfied)
---T(User Tired)
---None(No Input Gotten)

local vals, obs, v, oobj, _oobs

function StateMachine:observe(obj, _obs)

    vals = self._info
    obs = self._observations[_obs]
    oobj = obj
    
    obj.allEnemies = {}
    local re = obj:getObservable(theFunc) or None
    
    --very unlikely
    if not re or type(re)~="string" then
        error("No state switched in machine"..tostring(re))
        return None
    end
    
    return re
end

function StateMachine:inputIsTrue(input)
end

function StateMachine:doStatelessAI(action,obj)
    StatelessAI[action](obj)
end

function StateMachine:getProbShift(input)
    return (input and (input[2] or input.probability)) or 0
end
local coun = 0
theFunc = function(_tile)
        --tile should have smell, noise, and ...
        local tile = _tile--.id or tostring(_tile)
        local val = tile--vals[tile] or {}
        local obj = oobj
        coun = coun + 1
        if coun > 100 then
            _tile.room:yieldCoroutine()
            coun = 0
        end
        --if looking for a target, 50% to lose track if target is invisible
        if obj.target and not obj:tooFarFrom(obj.target) and (not obj:isInvisible() or math.random()>.5) then
            -- log("Did Yaaargh!!")
            return E
        else
            --if obj.target then log("dest") end
            --obj.target = nil
        end
        
        local unit = tile.unit and ((not ignorePlayer or not tile.unit.isPlayer) and tile.unit)
        local item = tile.item
        
        -- lose a unit if it's submerged in water and observer not in any kind of water
        if unit and unit:isSubmerged() and not obj.tile.water and math.random()>.5 then
            unit = nil
        end
        
        --[[for x, i in ipairs(_tile.units) do
            if i.isBojt or i.isPlayer then
                unit = i
                log("a unit ")
                --error("Unit!"..unit.class)
            end
        end]]
        
        if 1 then
                if obj.throwTarget then
                    return TH
                end
                
                if obj.toThrowFood then
                    return None
                end
                
                local canSee = true
                local dis
                if obj.sight > obj.vision then
                    dis = lume.distance(obj.x/tw, obj.y/th, _tile._x, _tile._y)
                    canSee = dis <= obj.vision
                end
                
                local spottedEnemy = unit and obj:isEnemy(unit) and not unit:isInvisible()
                
                if spottedEnemy then
                    local s = 11-unit:getStealth()
                    dis = dis or lume.distance(obj.x/tw, obj.y/th, _tile._x, _tile._y)
                    -- can't see enemy if outside stealth range
                    if dis > s then
                        canSee = false
                    elseif s<= 5 then
                        canSee = math.random(100)<=s*25
                        if canSee and (obj.isPlayer or unit.isPlayer) then
                            obj:addLog(string.format("%s noticed %s",obj.title, unit.title))
                        end
                    end
                end
                obj.canSee = canSee
                    
                local unitIsFood =  canSee and unit and obj:canEat(unit)
                local itemIsFood =  canSee and item and obj:canEat(item)
                
                if unitIsFood or itemIsFood then
                    -- be tempeted by food, but not for now
                    -- obj.nutrition = lume.max(lume.min(2,obj.nutrition),obj.nutrition - 1)
                    
                    obj.foodTarget = itemIsFood and item or unit
                    --obj:cry("food!!!"..obj.foodTarget.name) warn("foood???"..obj.foodTarget.name)
                end
                
                if obj.foodTarget and obj.lovesFood then
                    -- running away is more important than food
                    if unit and canSee and obj:isScaredOf(unit) then
                        obj.target = unit
                        return E
                    end
                    
                    return H
                end
                    
                
                -- if unit is not an ally return enemy seen
                if unit and obj:isEnemy(unit) and canSee then
                    local target = obj.attacker == obj.target and obj.target or unit
                    if nil then --obj.target and target ~= obj.target then
                        -- get closer target
                        local dis1 = lume.distance(obj.x, obj.y, target.x, target.y)
                        local dis2 = lume.distance(obj.x, obj.y, obj.target.x, obj.target.y)
                        
                        if dis1 < dis2 then
                            target = target
                        else
                            target = obj.target
                        end
                    end
                    
                    obj.target = unit--target
                    obj:cry("targ "..unit.name)
                    
                    obj.allEnemies[#obj.allEnemies+1] = obj.target
                    
                    if unit.data.name == obj.data.name then warn("INFIGHTING]"..tostring(obj.data.name)..","..tostring(obj.liking[unit])..","..tostring(obj.hostility)
                    ) end
                    
                    return E
                end
                
                if obj.throwTarget then
                    return TH
                end
                
                -- get a noise on the tile
                -- theoretically it's possible for the obj to miss a really loud sound
                -- oh well ...
                local noise = lume.randomchoice(_tile.noises or {})
                
                -- if noise then return noise heard
                if noise then
                    if noise[1] >= obj.hearing then 
                        --error(inspect(noise))--"rarg!!")
                        obj.noise = noise
                        return N
                    end
                end
                
                -- if hungry return hungry AI
                if obj:isHungry() then return H end
                
                -- smell!? Was I serious!? how deep did I make this
                -- if ... smell on tile return smell smelt

                v = val.smell
                if v then return S end

                -- check if dead ally is seen
                if unit and canSee then
                    if obj:isAlly(unit) and obj:isDead(unit) then
                        return D
                    end
                end
                
                -- check if an ally is seen

                if unit and obj:isAlly(unit) and unit ~= obj and canSee then
                    log("ally!!")
                    return F 
                end

                if obj:isSatieted() then
                   -- return SA
                end

                if obj:isTired() then
               --     return T
                end

              --  return None

        end
    end


return StateMachine