local c = creatures

-- some of the "smarter", more player like creatures

c.human_male = {
    name = "dude",
    anim = "creatures/dude",
    flipX = -1,
    group = {3,4},
    
    
    food = {
        pig = true,
        meat = true
    },
    
    leaderValue = 1,
    cowardice = 4,
    life = 12,
    strength = 2,
    defense = 3,
    playerDislike = -5,
    hostlity = 2,
    
    --alerter = {0,0,1,0,0,1,2},
    postMake = function(self)
    end
}

c.burlyman = {
    name = "burly man",
    anim = "creatures/buff_dude",
    flipX = -1,
    group = {3,4},
    
    
    food = {
        pig = true,
        meat = true
    },
    
    leaderValue = 1,
    cowardice = 0,
    life = 14,
    strength = 10,
    defense = 3,
    playerDislike = -5,
    hostlity = 2,
    
    --alerter = {0,0,1,0,0,1,2},
    postMake = function(self)
    end
}


c.goblin = {
    name = "goblin",
    anim = "creatures/goblin",
    group = {3,4},
    canSpeak = 1.4,
    
    tags = {goblin=true},
    liking = {orc=CLAN_HATRED},
    texts = GOBLIN_TEXTS,
    
    food = {
        pig = true,
        meat = true
    },
    
    spawn = {goblin=30,goblin_conjurer=10},
    leaderValue = 1,
    cowardice = 2,
    life = 7,
    --alerter = {0,0,1,0,0,1,2},
    postMake = function(self)
        if self.sprite then
        self.clothing = self:add_sprite(toybox.new_sprite(self, {
            animations = {
                idle = {
                    source = "creatures/goblin_clothe",
                    frameDelay = self.frameDelay or .15,
                    useImages = true,
                    mode = "loop"
                }
            }
        }))
        
        self.sprite.color = getColor(self.skinColor or "goblingreen")
        self.clothing.color = getColor(self.clothingColor or "goblinbrown")
        self.clothing:syncTo(self.sprite)
        
        self.sprite.useParentAlpha = true
        self.clothing.useParentAlpha = true
        else
            self.clothing = self:add_image("creatures/goblin_clothe/0.png")
            self.clothing.color = getColor(self.clothingColor or "goblinbrown")
            self.color = getColor(self.skinColor or "goblingreen")
            self.skinColor = self.color
        end
        
        if math.random() < 10.2 then
          --  makeShooter(self)
        end
    end
}


c.kobold = {
    name = "kobold",
    anim = "creatures/kobold",
    group = {3,4},
    
    tags = {kobold=true},
    liking = {},
    --texts = GOBLIN_TEXTS,
    
    lovesFood = true,
    food = {
        pig = true,
        meat = true
    },
    
    canSpeak = 1.9,
    speechSounds = KOBOLD_SPEECH_SOUNDS,
    
    spawn = {goblin=30,goblin_conjurer=10},
    leaderValue = 1,
    cowardice = 2,
    life = {3,5},
    cantRead = true,
    
    clothesOffset = 25,
}

c.minatour = {
    name = "minatour",
    anim = not "dagon" or "creatures/minatour",
    group = {3,4},
  --  w = tw*4, h=th*4*2,flipX=-1,
    tags = {kobold=true},
    liking = {},
    --texts = GOBLIN_TEXTS,
    
    lovesFood = true,
    food = {
        pig = true,
        meat = true
    },
    
    spawn = {goblin=30,goblin_conjurer=10},
    leaderValue = 1,
    cowardice = 2,
    life = {10, 15},
    strength = 3,
    speed = .75,
    cantRead = true,
    
    clothesOffset = -15,
}

c.ogre = {
    name = "ogre",
    anim = "creatures/ogre",
    group = {3,4},
    canSpeak = .7,
    
    tags = {ogre=true},
    liking = {},
    --texts = GOBLIN_TEXTS,
    
    w = tw*1.5, h = th*2*1.5,
    
    lovesFood = true,
    food = {
        pig = true,
        meat = true
    },
    
    leaderValue = 3,
    cowardice = 2,
    life = 20,
    strength = 4,
    weapon = "club"
    
    -- clothesOffset = 25,
}


local purplish = {.7,.4,.7}--colors.pink

c.old_fake_goblin_conjurer = {
    name = "goblin conjurer",
    anim = "creatures/goblin_conjurer",
    group = {3,4},
    --cowardice = 9,
    getAttack = function(self, n) return attacks.lightning(self, n) end,
    sikills = {
        conjure = 1
    },
    
    light = {1,"pink"},
    life = 5,
    
    tags = {goblin=true},
    liking = {orc=CLAN_HATRED},

}


c.goblin_conjurer = {
    name = "goblin conjurer",
    anim = "creatures/goblin",
    group = {3,4},
    
    --cowardice = 9,
    
    getAttack = function(self, n) return attacks.lightning(self, n) end,
    sikills = {
        conjure = 1
    },
    
    canSpeak = 1.2,
    speechSounds = MAGIC_SPEECH_SOUNDS,
    
    tags = {goblin=true},
    liking = {orc=CLAN_HATRED},
    texts = GOBLIN_TEXTS,
    food = c.goblin.food,
    
    light = {1,"pink"},
    life = 5,
    helmet = "wizard_cap",

    postMake = function(self)
        if self.sprite then
        self.clothing = self:add_sprite(toybox.new_sprite(self, {
            animations = {
                idle = {
                    source = "creatures/goblin_clothe",
                    frameDelay = self.frameDelay or .15,
                    useImages = true,
                    mode = "loop"
                }
            }
        }))
        
        self.sprite.color = getColor(self.skinColor or "goblingreen")
        self.clothing.color = getColor(self.clothingColor or "lightpurple")
        self.clothing:syncTo(self.sprite)
        
        self.sprite.useParentAlpha = true
        self.clothing.useParentAlpha = true
        
        else
            self.clothing = self:add_image("creatures/goblin_clothe/0.png")
            self.clothing.color = getColor(self.clothingColor or "goblinbrown")
            self.color = getColor(self.skinColor or "goblingreen")
            self.skinColor = self.color
        end
        
        if math.random() < 10.2 then
          --  makeShooter(self)
        end
    end
}


c.lich = {
    name = "Lich",
    anim = "creatures/lich",
    
    w = tw*1.5,
    h = th*2*1.5,
    
    canSpeak = .9,
    speechSounds = MAGIC_SPEECH_SOUNDS,
    
    isLiving = false,
    light = {10, "lime"},
    cowardice = 0,
    life = {30,50},
    noBlood = true,
    abilities = {
        revive = {
            object = "skull"
        }
    },
    hostility = 2,
    skills = {divinity=1},
    -- blood:bones
    updateTurn = function(self)
        
    end,
    
    immuneTo = {
        burn = true
    }
}

c.orc = lume.copy(c.goblin)
local orc = c.orc
orc.anim = "creatures/orc"
orc.name = "orc"
orc.tags = {orc=true, swine=true}
orc.canSpeak = .8
orc.food = lume.copy(c.goblin.food)
orc.food.swine = false
orc.liking = {goblin=-CLAN_HATRED, swine=10, pig=10, chicken=-5}
orc.postMake = nil
orc.texts = ORC_TEXTS

c.gobliyn = c.goblin_conjurer