data.rooms = {}
rooms = data.rooms
local r = rooms
local i = rooms

dungeon = {}

--[[
summonTrapPedestal
graveyardRoom
headstoneRoom
statueChallengeRoom
trapRoom
warRoom
]]

--[[
Tags for rooms
    - startingRoom
    - endingRoom
    
    - rewardRoom
    - plantRoom
    - holyRoom
    - statueRoom
    - cursedRoom
    - noSpawn
    - enemyRoom
    - battleRoom
    - shop

]]

function buildGoblinWarren(tile, map)
    local tiles = {tile}
    local maxSize = 25
    local minSize = 10
    local xs, ys = 1, 1
    local done
    for x = tile._x, tile._x+maxSize do
        for y = tile._y, tile._y+maxSize do
            local t = map:getTile(x, y)
            if t and not t.edge then
            --    ys = ys+1
            else
                done = true
                break
            end
        end
        ys = ys + 1
        xs = xs + 1
        if done then
            break
        end
    end
    
    if xs < minSize or ys < minSize then
        return
    end
    
    local function make()
    end
    
    local digger = toybox.rot().Map["Uniform"](xs, ys, {
            caveChance = 0,
            chavePasses = 3,
            maxRooms = 12,--,12, 
            minRooms = 10,--8,
            maxCorridorsPerRoom = 3,
            roomWidth = {2,2,2,3,3,4},--{3,4 or 6},
            roomWi4dth = {6,8},
            roomtHeight = {2,2,2,2,3,3,4},
            croussWidth = {0,0},
            crossHieight = {0,0},
            -- maxRooms = 11
     
            corridorWidth  = {1,1,1,1,1,2,2,2,4,5},--,10},
            corridorHeight = {1,1,1,1,1,1,3,5,2},--10},
            corridorChance = .3 or .9,
    })
    
    digger:create(make)
    
    local emptyTiles, emptyTile = {}
    
    local function build(x, y, val)
        local ttile = map:getTile(tile._x+x, tile._y+y) if y==0 then error() end
        if not ttile then log(x..","..y..","..tile._x..","..tile._y) return nil end
        
        ttile.hasDoor = false
        
        ttile.soily = true
        
        if val == 1 and not ttile.hasDoor and not tile.water then
            ttile.solid = true
        elseif not ttile.keepSolid and not ttile.edge then
            ttile.solid = false
            emptyTile = ttile
            emptyTiles[#emptyTiles+1] = ttile
        end
        
        ttile:removeWater()
        
        ttile.chasm = nil
        
        ttile.isDug = true
        
        ttile.draw_uafter = function(self) set_color(1,1,0,.3) draw_rect("fill", self.x, self.y, self.w, self.h) set_color(1,1,1,1) end
        
        return ttile
    end
    
    for x, c in ipairs(digger._corridors) do
        local length = c._length
        local dx, dy = c._dx, c._dy
        local sx, sy = c._sx, c._sy
        for i=-1,length-1+1 do
            local x=sx+i*dx
            local y=sy+i*dy
        
            local ttile = map:getTile(tile._x+x, tile._y+y)
            if ttile and not ttile.keepSolid then
                ttile.solid = false
                ttile.hasDoor = false
                ttile.isCorridor = true
            end
            
            for xx = 1, 2 do
                local val = xx == 2 and -1 or xx
                local valx = dx == 0 and val or 0
                local valy = dy == 0 and val or 0
                ttile = map:getTile(tile._x+x+valx, tile._y+y+valy)
                if ttile and not ttile.hasDoor and not ttile.isCorridor then
                    ttile.solid = true
                end
            end
        end
    end
    
    local rooms = {}
    local theRoom
    for x , room in ipairs(digger.getRooms and digger:getRooms() or {}) do
        local ro = Room:new({
            parent = map,
            data = room,
            real = true,
            useMap = digger._map,
            useMapFunction = build,
            dx = tile._x, dy = tile._y -- = false
        })
        ro.isDug = true
        rooms[#rooms+1] = ro
    end
    
    
    local d = {}
    for _, door in ipairs(digger.getDoors and digger:getDoors() or {}) do
        local t = map:getTile(door.x+tile._x, door.y+tile._y)
        if t and not t.door then
            t:makeDoor()
            d[#d+1] = t
            --t.draw_after = function(self) set_color(1,0,0,.3) draw_rect("fill", self.x, self.y, self.w, self.h) set_color(1,1,1,1) end
        
        end
    end
    
    tile.room.walkableFunction = function(self, x, y)
        local tt = self:getTile(x, y)
        if not tt or tt.edge or tt.chasm or tt.water then
            return
        elseif tt.isDug then
            return true
        else
            return not tt.solid and not tt.water and not tt.chasm
        end
    end
    
    local function check(x,y)
        return tile.room:isWalkable(x,y)
    end
    
    FEATURE = emptyTiles
    theRoom = getValue(rooms)
    
    local path = {}
    local function buildPath(x,y)
        local pp = {}--_Path:new(x,y)
        pp.tile = tile.room:getTile(x,y)
        if pp.tile.solid and pp.tile.isDug then
            pp.tile.solid = false
            pp.tile:removeWater()
            pp.tile:makeDoor()
            theRoom = pp.tile.roomData or error("No room data")
            assert(theRoom.isDug)
        end
        table.insert(path,pp)
    end
    
    local tr
    local count = 100
    while not tr or tr.isDug do
        tr = tile.room:getRandomSpaceTile()
        count = count-200
        if count <= 0 then
            break
        end
    end
    
    goal = {x=emptyTile._x,y=emptyTile._y}
    start = {x=tr._x,y=tr._y}
    local pth = rot.Path.AStar(goal.x,goal.y,check, {toplogy=4})
    pth:compute(start.x,start.y,buildPath)
    
    tile.room.walkableFunction = nil
    
    for x, room in ipairs(rooms) do
    
        if room ~= theRoom then
        
            local emptyTile = room:getRandomSpaceTile()
            local tr = theRoom:getRandomSpaceTile()
            
            tile.room.walkableFunction = function(self, x, y)
                local tt = self:getTile(x, y)
                if not tt or tt.edge or tt.chasm or tt.water then
                    return
                else
                    return not tt.solid and not tt.water and not tt.chasm
                end
            end
    
            local function check(x,y)
                return tile.room:isWalkable(x,y)
            end
    
    
            local path = {}
            local function buildPath(x,y)
                local pp = {}--_Path:new(x,y)
                pp.tile = tile.room:getTile(x,y)
                if nil then--pp.tile.solid and pp.tile.isDug then
                    pp.tile.solid = false
                    pp.tile:makeDoor()
                    pp.tile:removeWater()
                end
                table.insert(path,pp)
            end
    

            goal = {x=emptyTile._x,y=emptyTile._y}
            start = {x=tr._x,y=tr._y}
            local pth = rot.Path.AStar(goal.x,goal.y,check, {toplogy=4})
            pth:compute(start.x,start.y,buildPath)
            
            if #path == 0 then
                
                tile.room.walkableFunction = function(self, x, y)
                    local tt = self:getTile(x, y)
                    if not tt or tt.edge or not tt.isDug then
                        return
                    end
                end
    
                local function check(x,y)
                    return tile.room:isWalkable(x,y)
                end
    
                local path = {}
                local function buildPath(x,y)
                    local pp = {}--_Path:new(x,y)
                    pp.tile = tile.room:getTile(x,y)
                    if pp.tile.solid and pp.tile.isDug then
                        pp.tile.solid = false
                        pp.tile:removeWater()
                    end
                    table.insert(path,pp)
                end

    
                goal = {x=emptyTile._x,y=emptyTile._y}
                start = {x=tr._x,y=tr._y}
                local pth = rot.Path.AStar(goal.x,goal.y,check, {toplogy=4})
                pth.heuristic = function(self, x, y)
                    local t = tile.room:getTile(x, y)
                    if t then
                        return t.solid and 0 or 1
                    end
                end
                
                pth:compute(start.x,start.y,buildPath)
            end
    
            tile.room.walkableFunction = nil
            
        end
    end
    
    local g
    for x = 1, 10 do
        local r = getValue(rooms)
        local gg = tile.room:spawn("goblin", r:getRandomSpaceTile())
        if x == math.random(5,8) then
            g = nil
        end
        if g then
            gg:makeLeader(g)
        end
        g = g or gg
        gg.nutrition = 0
    end
    
    for x = 1, 10 do
        local r = getValue(tile.room.rooms)
        tile.room:spawn(x==1 and "monkey" or x==10 and "boar" or "pig", r:getRandomSpaceTile()).nutrition = 0
    end
    
    for x = 1, 10 do
        local r = getValue(tile.room.rooms)
        tile.room:spawn(x==10 and "boar" or "kobold", r:getRandomSpaceTile()).nutrition = 0
    end
    
    local items = {
        potion_of_flames = 20,
        potion_of_haste = 10,
        potion_of_descent = 2,
        potion_of_invisibility = 7,
    }
    
    for xi = 1, 20 do
        local r = math.random()
        local i
        if r < 60 then
            i = getRandomPotion()
        elseif r < 80 then
            i = getRandomScroll()
        elseif r < 90 then
            i = getRandomWand()
        end
        
        local done = spawnImportantItem(tile, .35) or tile.room:spawnItem(i, (getValue(rooms)):getRandomSpaceTile())
    end
    
    for xi = 1, 1 do -- math.random(1,2) do
        local done = spawnLoreNote((getValue(rooms)):getRandomSpaceTile(), "goblin")
    end
    
    local function reachGoal(n, self)
        self.goalTile = getValue(emptyTiles)
    end
    
    spawnGroup({orc=10, boar=1}, {3,5}, function(cr, isLeader)
        if isLeader then
            cr.goalTile = getValue(emptyTiles)
            cr:onReachGoal(reachGoal)
        end
    end)
    
    for x = 1, math.random(4, 8) do
        tile.room:spawnItem("explosive_barrel", (getValue(rooms)):getRandomSpaceTile())
    end
        
    return true
end

function spawnGroup(creatures, num, func, tile)
    local leader
    local tile = tile or toybox.room:getRandomSpaceTile()
    
    for x = 1, getValue(num) do
        local cr = toybox.room:spawn(creatures[1] and getValue(creatures) or lume.weightedchoice(creatures), tile)--pl.tile)
        if not leader and cr then
            leader = cr
        elseif cr then
            cr:makeLeader(leader)
        end
        
        if func and cr then
            func(cr, cr == leader)
        end
    end
    
    return leader
end


function buildLabyrinth(tile, map)
    local tiles = {tile}
    local maxSize = 25
    local minSize = 10
    local xs, ys = 1, 1
    local done
    for x = tile._x, tile._x+maxSize do
        for y = tile._y, tile._y+maxSize do
            local t = map:getTile(x, y)
            if t and not t.edge then
            --    ys = ys+1
            else
                done = true
                break
            end
        end
        ys = ys + 1
        xs = xs + 1
        if done then
            break
        end
    end
    
    if xs < minSize or ys < minSize then
        return
    end
    
    local emptyTiles, emptyTile = {}
    
    local function build(x, y, val)
        local ttile = map:getTile(tile._x+x, tile._y+y) if y==0 then error() end
        if not ttile then log(x..","..y..","..tile._x..","..tile._y) return nil end
        
        ttile.hasDoor = false
        if val == 1 and not ttile.hasDoor and not tile.water then
            ttile.solid = true
        elseif not ttile.keepSolid and not ttile.edge then
            ttile.solid = false
            emptyTile = ttile
            emptyTiles[#emptyTiles+1] = ttile
        end
        
        if x <= 1 or x == xs or y <= 1 or y == ys then
            if not ttile.keepSolid and not ttile.edge and not ttile.water then
                ttile.solid = false
            end
        end
        
        ttile:removeWater()
        tile.isMaze = true
        
        ttile.chasm = nil
        
        ttile.isDug = true
        
        -- ttile.draw_after = function(self) set_color(1,1,0,.3) draw_rect("fill", self.x, self.y, self.w, self.h) set_color(1,1,1,1) end
        
        return ttile
    end
    
    local digger = toybox.rot().Map["IceyMaze"](xs, ys, {
            caveChance = 0,
            chavePasses = 3,
            maxRooms = 12,--,12, 
            minRooms = 10,--8,
            maxCorridorsPerRoom = 3,
            roomWidth = {2,2,2,3,3,4},--{3,4 or 6},
            roomWi4dth = {6,8},
            roomtHeight = {2,2,2,2,3,3,4},
            croussWidth = {0,0},
            crossHieight = {0,0},
            -- maxRooms = 11
     
            corridorWidth  = {1,1,1,1,1,2,2,2,4,5},--,10},
            corridorHeight = {1,1,1,1,1,1,3,5,2},--10},
            corridorChance = .3 or .9,
    })
    
    digger:create(build)
    
    for x = 1, #emptyTiles do
        local t = emptyTiles[x]
        if t and t.solid then
            table.remove(emptTiles, x)
        end
    end
    
    assert(#emptyTiles>0)
    
    emptyTile = getValue(emptyTiles)
    FEATURE = emptyTiles
    local tr = map.player.tile
    
    local min = map:spawn("minatour", getValue(emptyTiles))
    min.patrolTiles = emptyTiles
    
    
    tile.room.walkableFunction = nil
    
    do
        tile.room.walkableFunction = function(self, x, y)
            local tt = self:getTile(x, y)
            if not tt or tt.edge or tt.chasm or tt.water then
                return
            else
                return not tt.solid and not tt.water and not tt.chasm
            end
        end
    
        local function check(x,y)
            return tile.room:isWalkable(x,y)
        end
    
    
        local path = {}
        local function buildPath(x,y)
            local pp = {}--_Path:new(x,y)
            pp.tile = tile.room:getTile(x,y)
            table.insert(path,pp)
        end
    

        goal = {x=emptyTile._x,y=emptyTile._y}
        start = {x=tr._x,y=tr._y}
        local pth = rot.Path.AStar(goal.x,goal.y,check, {toplogy=4})
        pth:compute(start.x,start.y,buildPath)
            
        if #path == 0 then
            tile.room.walkableFunction = function(self, x, y)
                local tt = self:getTile(x, y)
                if not tt or tt.edge then
                    return
                end
                
                return true
            end
    
            local function check(x,y)
                return tile.room:isWalkable(x,y)
            end
    
            local path = {}
            local function buildPath(x,y)
                local pp = {}--_Path:new(x,y)
                pp.tile = tile.room:getTile(x,y)
                if pp.tile.solid then--and pp.tile.isDug then
                    pp.tile.solid = false Ph = pp.tile
                    pp.tile:removeWater()
                end
                table.insert(path,pp)
            end
            

    
            goal = {x=emptyTile._x,y=emptyTile._y}
            start = {x=tr._x,y=tr._y}
            local pth = rot.Path.AStar(goal.x,goal.y,check, {toplogy=4})
            pth.heuristic = function(self, x, y)
                local t = tile.room:getTile(x, y)
                if t then
                    return t.solid and 0 or 1
                end
            end
                
            pth:compute(start.x,start.y,buildPath)
            -- assert(Ph)
        end
    
        tile.room.walkableFunction = nil
            
    end
    
    
    local ti = map.player.tile
    
    return true
end

function buildGoblinCamp(tile, map, room, creatureData)
    local l
    if not room then
        if true then-- room == false then
        
            local tiles = {tile}
            local maxSize = 6
            local minSize = 3
            local xs, ys = 1, 1
            local done
            for x = tile._x, tile._x+maxSize do
                for y = tile._y, tile._y+maxSize do
                    local t = map:getTile(x, y)
                    tiles[#tiles+1] = t
                    if t and not t.edge then
                    --    ys = ys+1
                    else
                        done = true
                        break
                    end
                end
                ys = ys + 1
                xs = xs + 1
                if done or xs > maxSize or ys > maxSize then
                    break
                end
            end
    
            if xs < minSize or ys < minSize then
                return
            end
            
            local room = { isFake = true }
            toybox.make_grid(room)
            for x, i in ipairs(tiles) do
                -- i.__draw = function(self) draw_rect("fill", self.x, self.y, self.w, self.h) end
                room:storeTile(i, i._x, i._y)
                i.roomData = room
            end
            
        end
        
        room = room or getValue(map.rooms) or error()
    end
    
    l = room
    
    
    if not l.isFake or true then
        local count = 0
        for x = l.minTileX, l.maxTileX do
            for y = l.minTileY, l.maxTileY do
                local t = map:getTile(x, y)
                local isEdge = t and
                  (x==l.minTileX or x==l.maxTileX) or 
                  (y==l.minTileY or y==l.maxTileY)
                          
                if t and not t.isCorridor and isEdge and count<4 and math.random()>.6 then
                    t.solid = true
                    t.keepSolid = true
                    count = count + 1
                end
            end
        end
                
        for x, d in pairs(l.doors) do
            --d:makeDoor(true)
        end
    end
                
    local fire = map:spawnItem("campfire",l:getRandomSpaceTile())
    if not fire then
        return
    end
                
    local crs = map:spawnFromData("goblin",l,nil, creatureData or {
            3,
            index = "goblin",
            intensity = 1,
            group = {1,1,1,2},
            leader = true
    })
    
    -- assert(crs[])
        
    -- map:spawn("pig",l:getRandomSpaceTile())
    rooom = fire.tile
    
    
    if not crs then return end
    
    
    for x = 1,#crs do
        crs[x].campfire = fire
        crs[x].currentState = "Dancing"
        local c = crs[x]
        c.waiting = true
    end
    
    local crsCopy = lume.copy(crs)
    for x = 1, #crs do
        local c = lume.eliminate(crsCopy)
                    
        local ocl = c.leader
        c.leader = nil
        
        c.currentState = "Hungry"
        
        c.grabFood = function(self, food)
            return not food.isCooked and food.tile ~= fire.tile
        end
        
        c.isHunting = true
        
        gob = c
        c.gob = true
        
        c.onGrabFood = function(self, iten)
            c.noChangeState = true
            c.toThrowFood = true
            c:onStartTurn(function()
                if (c.tile.roomData == l or lume.distance(c.tile._x, c.tile._y, fire.tile._x, fire.tile._y) <= 10) and not c.thrown then
                    c.toThrow = c:getFoodItem()
                    c.throwDistance = 3
                    if c.toThrow then
                        c.toThrow.onCooked = function(food)
                            for x = 1, #crs do
                                crs[x].isHunting = true
                            end
                        end
                                
                        c.throwTarget = fire.tile
                        c.thrown = true
                    end
                    c.noChangeState = false
                    c.toThrowFood = nil
                else
                    c.goalTile = l:getRandomSpaceTile()
                    local count = 0
                    while lume.distance(c.goalTile._x, c.goalTile._y, fire.tile._x, fire.tile._y) > 10 do
                        c.goalTile = l:getRandomSpaceTile()
                        count = count + 1
                        if count > 50 then c.room:addLog('Yikes')
                            break
                        end
                    end
                    
                end
            end)
            pl:cry("foooooooood")
            c.goalTile = l:getRandomSpaceTile()
            c.currentState = "Curious"
            c.isHunting = false
            c.leader = ocl cwarn("Grabbed ","pink")
            -- c.grabFood = false
        end
    end
    
    return true
end



function buildKoboldCamp(tile, map, room)
    return buildGoblinCamp(tile, map, room, {
            3,
            index = "kobold",
            intensity = 1,
            group = {1,1,1,2},
            leader = true
    })
end

function getRoom(tile, map, room, min, max)
    local l
    if not room then
        if true then-- room == false then
        
            local tiles = {tile}
            local maxSize = max or 6
            local minSize = min or 3
            local xs, ys = 1, 1
            local done
            for x = tile._x, tile._x+maxSize do
                for y = tile._y, tile._y+maxSize do
                    local t = map:getTile(x, y)
                    tiles[#tiles+1] = t
                    if t and not t.edge then
                    --    ys = ys+1
                    else
                        done = true
                        break
                    end
                end
                ys = ys + 1
                xs = xs + 1
                if done or xs > maxSize or ys > maxSize then
                    break
                end
            end
    
            if xs < minSize or ys < minSize then
                return
            end
            
            local room = { isFake = true }
            toybox.make_grid(room)
            for x, i in ipairs(tiles) do
                -- i.__draw = function(self) draw_rect("fill", self.x, self.y, self.w, self.h) end
                room:storeTile(i, i._x, i._y)
            end
            
        end
        
        room = room or getValue(map.rooms) or error()
    end
    
    l = room
    
    if not l.isFake or true then
        local count = 0
        for x = l.minTileX, l.maxTileX do
            for y = l.minTileY, l.maxTileY do
                local t = map:getTile(x, y)
                local isEdge = t and
                  (x==l.minTileX or x==l.maxTileX) or 
                  (y==l.minTileY or y==l.maxTileY)
                          
                if t and not t.isCorridor and isEdge and count<4 and math.random()>.6 then
                    t.solid = true
                    t.keepSolid = true
                    count = count + 1
                end
            end
        end
                
        for x, d in pairs(l.doors) do
            --d:makeDoor(true)
        end
    end
    
    return l
end

function buildCreatureRoom(tile, map, room, creatureData, patrolTiles)
    local l
    if not room then
        if true then-- room == false then
        
            local tiles = {tile}
            local maxSize = 6
            local minSize = 3
            local xs, ys = 1, 1
            local done
            for x = tile._x, tile._x+maxSize do
                for y = tile._y, tile._y+maxSize do
                    local t = map:getTile(x, y)
                    tiles[#tiles+1] = t
                    if t and not t.edge then
                    --    ys = ys+1
                    else
                        done = true
                        break
                    end
                end
                ys = ys + 1
                xs = xs + 1
                if done or xs > maxSize or ys > maxSize then
                    break
                end
            end
    
            if xs < minSize or ys < minSize then
                return
            end
            
            local room = { isFake = true }
            toybox.make_grid(room)
            for x, i in ipairs(tiles) do
                -- i.__draw = function(self) draw_rect("fill", self.x, self.y, self.w, self.h) end
                room:storeTile(i, i._x, i._y)
            end
            
        end
        
        room = room or getValue(map.rooms) or error()
    end
    
    l = room
    
    if not l.isFake or true then
        local count = 0
        for x = l.minTileX, l.maxTileX do
            for y = l.minTileY, l.maxTileY do
                local t = map:getTile(x, y)
                local isEdge = t and
                  (x==l.minTileX or x==l.maxTileX) or 
                  (y==l.minTileY or y==l.maxTileY)
                          
                if t and not t.isCorridor and isEdge and count<4 and math.random()>.6 then
                    t.solid = true
                    t.keepSolid = true
                    count = count + 1
                end
            end
        end
                
        for x, d in pairs(l.doors) do
            --d:makeDoor(true)
        end
    end
    
    local crs = map:spawnFromData("goblin",l,nil, creatureData or {
            3,
            index = "juggernaut_beetle",
            intensity = 1,
            group = {3,4,2,3},
            leader = false
    })
    log("done creature room spawn")
    if patrolTiles then
        local tiles = {}
        for x, t in ipairs(l.allTiles) do
            if not t.solid then
                tiles[#tiles+1] = t
            end
        end
    
        for x, cr in ipairs(crs) do
            cr.patrolTiles = tiles
        end
    end
    
    return true
end


function buildJuggernautNest(tile, map, room)
    return buildCreatureRoom(tile, map, room, {
            3,
            index = "juggernaut_beetle",
            intensity = 1,
            group = {3,4,2,3},
            leader = false
    })
end

function buildBatCave(tile, map, room)
    -- todo: add a big bat leader
    log("bat cave bulding...")
    return buildCreatureRoom(tile, map, room, {
            3,
            index = "bat",
            intensity = 1,
            group = {3,4,2,3},
            leader = false
    }, true)
end

function buildBattleStatueItem(tile, map, room)
    -- map:spawn("battle_statue", pl.tile)
    -- if 1 then return true end
     
    local l = getRoom(tile, map, room)
    if not l then
        return
    end
    
    local crs = {}
    
    
    local count, item = 10
    while not item do
        count = count - 1
        if count < 0 then
            break
        end
        
        item = map:spawnItem(getImportantItem(.8) or getWeaponReward(), l:getRandomSpaceTile())
    end
    
    if not item then
        return
    end
    
    local oc = item.onCarry
    item.onCarry = function(self, user)
        for x, statue in ipairs(crs) do
            statue:activate()
        end
    end
    
    item.tile.pedestal = true
    
    for x = 1, math.random(2, 4) do
        local torch = map:spawnItem("torch", l:getRandomSpaceTile())
        if torch then
            torch.tile.pedestal = true
        end
    end
    
    for x = 1, 5 do
        local count, t = 10
        while not t do
            t = l:getRandomSpaceTile()
            if t and t.item then
                t = nil
            end
            count = count - 1
            if count < 0 then
                break
            end
        end
        
        local c = t and map:spawn("battle_statue", t)
        if c then
            crs[#crs+1] = c
            c.team = "gaurd"
        end
    end
    
    return true
    
end

function buildChasmItem(tile, map, room, depth)
    local tilesToUse = {}
    local markedTiles = {}
    local edgeTiles = {}
    
    local depth = math.random(1,depth or 3)
    
    
    for x = -depth, depth do
        for i = -depth, depth do--xx, i in ipairs(dirs8) do

            local t = map:getTile(tile._x+x, tile._y+i)--i[1]*x, tile._y+i[2]*x)
            if t and t~=tile then
                tilesToUse[#tilesToUse+1] = t
                markedTiles[t] = true
                if x == depth then
                    edgeTiles[#edgeTiles+1] = t
                end
                if t.unit then return end
                if t.chasm then return end
            end
            
        end
    end
    
    for x, i in ipairs(edgeTiles) do
        local surrounded = 0
        for xx, d in ipairs(dirs8) do
            local t = map:getTile(i._x+d[1], i._y+d[2])
            if t and not markedTiles[t] and not t.chasm and not t.solid then
                surrounded = surrounded + 1
            end
            
            if surrounded >= 3 then
                break
            end
        end
        
        -- invalid tile for room
        if surrounded < 3 then
            if depth == 1 then
                return
            else
                return buildChasmItem(tile, map, room, depth-1)
            end
        end
    end
    
    for x, i in ipairs(tilesToUse) do
        i.chasm = true
    end
    
    
    tile.solid = false
    tile.chasm = false
    
    tile.pedestal = true
    map:spawnItem(getImportantItem(.5) or getWeaponReward(), tile)
    
    return true
end

function buildItemGraveRoom(tile, map, room)

    local l = getRoom(tile, map, room)
    if not l then
        return-- er()
    end
    
    local crs = {}
    
    
    local count, item = 10
    while not item do
        count = count - 1
        if count < 0 then
            break
        end
        
        item = map:spawnItem(getImportantItem(.8) or getWeaponReward(), l:getRandomSpaceTile())
    end
    
    if not item then
        return
    end
    
    
    local oc = item.onCarry
    item.onCarry = function(self, user)
        for x, statue in ipairs(crs) do
            statue:shake(20,1,20)
            local function f()
                statue:getAttacked(10, item)
            end
            map:after(1, f)
        end
    end
    
    item.tile.pedestal = true
    
    for x = 1, math.random(2, 4) do
        local torch = map:spawnItem("torch", l:getRandomSpaceTile())
        if torch then
            torch.tile.pedestal = true
        end
    end
    
    for x = 1, 5 do
        local count, t = 10
        while not t do
            t = l:getRandomSpaceTile()
            if t and t.item then
                t = nil
            end
            count = count - 1
            if count < 0 then
                break
            end
        end
        
        local c = t and map:spawnItem("cursed_gravestone", t)
        
        if c then
            crs[#crs+1] = c
            c.team = "gaurd"
        end
    end
    
    if #crs <=0 then
        item.tile.pedestal = nil
        item:destroy()
    end
    
    
    return true
end

r.shop_room = {
    roomLevel = 2,
    
    tags = {
        shop = true,
        noSpawn = true
    },
    
    checkRoom = {
        startingRoom = false
    },
    
    shop = {
        shopkeeper = "burlyman",
        shopType = {
            library = {
                weight = 10,
                itemPool = "library",
                priceIncrement = 1,
                addon = 0,
                greeting = {"Welcome to my library, %s!"}
            },
            
            chemist = {
                weight = 10,
                itemPool = "chemist",
                priceIncrement = 1,
                greeting = {"Welcome to my pharmacy, %s!"}
            },
            
            general = {
                weight = 10,
                itemPool = "general",
                priceIncrement = 1,
                greeting = {"Welcome to my shop, %s!"}
            },
            
        }
    },
    
    preMake = function(l, map)
        do local c=0
                for x = l.minTileX, l.maxTileX do
                    for y = l.minTileY, l.maxTileY do
                        local t = map:getTile(x, y)
                        local isEdge = t and
                          (x==l.minTileX or x==l.maxTileX) or 
                          (y==l.minTileY or y==l.maxTileY)
                          
                        if t and not t.isCorridor and not t.isEntrance and isEdge and not t.stairs then
                            t.solid = false c=c+1
                            map:spawnItem("woodenWall",t,true)
                            -- t.keepSolid = true
                            t.isCorridor = true
                            t.isEntrance = true
                        elseif t and not isEdge and not t.stairs then
                            map:spawnItem("woodenFloor",t)
                            t.isCorridor = true
                        end
                    end
                end assert(c>4)
        end
    end,
    
    postMake = function(l, map)
        l.shopkeeper.currentState = "Dancing"
        
    end
    
}

r.flamesprout_room = {

    roomLevel = 1,
    minRoomLevel = 1,
    maxRoomLevel = 5,
    
    tags = {
        plantRoom = true
    },

    name = "flamesprout_room",
    spawnItem = {
        flamesprout = {1, {2,4}}
    },
    chanceToSpawn = 10
}

r.pooleaf_room = {
    name = "pooleaf_room",
    spawnItem = {
        pooleaf = {1, {1,1,1,1,2}}
    },
    
    tags = {
        plantRoom = true
    },
    
    chanceToSpawn = 10
}

r.angel_statue_room = {
    roomLevel = 3,
    spawnItem = {
        angel_statue = {1, 1}
    },
    
    tags = {
        statueRoom = true
    },
    
    chanceToSpawn = 3,
}

r.cursed_statue_room = {
    roomLevel = 4,
    
    spawnItem = {
        cursed_statue = {1,1}
    },
    
    tags = {
        statueRoom = true
    },
    
    chanceToSpawn = 2,
}

r.pedestal_reward_room = {
    items = {
        amount = 4,
        pool = "rewardPool",
        pedestalLocked = true,
        onPedestal = true,
    },
    
    tags = {
        rewardRoom = true
    }
}

r.weapon_reward_room = {
    items = {
        amount = 1,
        pool = "weaponPool",
        pedestalLocked = true,
        onPedestal = true,
    },
    
    tags = {
        rewardRoom = true
    }
}

i.scroll_reward_room = {
   itemData = {
        items = getRandomScroll,
        enchants = {0,0,0,1,1,2},
        amount = {2,3,3,3,3,4}
    },
    
    tags = {
        rewardRoom = true
    }
}

i.potion_reward_room = {
    itemData = {
        items = getRandomPotion,
        enchants = {0,0,0,1,1,2},
        amount = {2,3,3,3,3,4}
    },
    
    tags = {
        rewardRoom = true
    }
}

i.wand_reward_room = {
    itemData = {
        items = getRandomWand,
        enchants = {0,1,1,2,2,1,1,1,2,2,3,0,5},
        amount = {2,3,3,3,3,4}
    },
    
    tags = {
        rewardRoom = true
    }
}

i.scroll_of_enchanting_reward_room = {
    itemData = {
        items = {"scroll_of_enchanting"},
        enchants = {0,0,0,1,1,2},
        amount = {1,1,1,2,2,2,2,1,1,1,3}
    },
    
    tags = {
        rewardRoom = true
    }
}

i.angel_statue_potion_reward_room = {
    itemData = {
        itemsByWeight = {
            potion_of_healing = 5,
            potion_of_life = 1,
            potion_of_haste = 2,
            potion_of_protection = 2
        },
        enchants = {0,0,0,1,1,2},
        amount = {2,3,3,3,3,4}
    },
    
    spawnItem = "angel_statue",
    
    tags = {
        rewardRoom = true,
        statueRoom = true,
        holyRoom = true
    }
}
    
i.statue_challenge_room = {
    tags = {
        battleRoom = true,
        rewardRoom = true,
        statueRoom = true
    },
    
    postMake = function(room, map)
        local sta = map:spawn("battle_statue", room:getRandomSpaceTile())
        
        sta:addClass(getValue({"warrior"}))
    end
}
    
r.single_pedestal_reward_room = {

    tags = {
        rewardRoom = true
    },
    
    items = {
        amount = 1,
        pool = "rewardPool",
        --pedestalLocked = true,
        onPedestal = true,
    },
    
    checkRoom = {
        battleRoom = false,
        rewardRoom = false,
        lockedRoom = false
    },
    
    chanceToSpawn = 10,
    max = 2
    
}

for x, i in pairs(r) do
    i._id = i._id or x
    i.name = i.name or x
end