
items.lore_note = {
    name = "Note",
    useText = "read",
    source = "items/note.png",
    life = 1,
    onUse = function(self, user)
        -- game.secrets = game.secrets + 1
        -- user:addLog("The note reads: &colors.yellow 'The ... has the madness. It made the orb. Destroy at all costs. Run or ... will kill you. The ... isn't a Lich. There's also a ...' ~ \nThe rest is illegible.")
        self.text = self.text or getLoreText()
        log(self.text)
        gooi.alert({
            text = string.format('The note reads:\n \n"%s"', self.text),
            big = true,
            w = W()*.47,
            h = H()*.5
        })
        self.info = string.format('The note reads:\n \n"%s"', self.text)
    end,
    
    info = "There seems to be something written here...",
    
    postMake = function(self)
        -- commented out to save lore texts
        -- self.text = self.text or getLoreText()
        -- self.info = self.text
        
        self:makeDifferentFromStack()
    end
}

function spawnLoreNote(tile, category, chance, notCategory)
    local loreNote = tile.room:spawnItem("lore_note", tile)
    loreNote.text = getLoreText(category, chance, notCategory)
    return loreNote
end

function lore()
    pl:forceAddItem("lore_note")
end

function getLoreText(category, chance, notCategory)
    -- chance is probability category will match
    local r = chance or .65
    local text
    if category and math.random() < r then
        text = data.lore[category] or error("No lore "..category)
        if #text <= 0 then
            data.lore[category] = lume.copy(data._lore[category])
        end
        text = getValue(data.lore[category]) or error("Nope")
    else
        text = lume.randomchoice(lume.keys(data.lore))
        if #data.lore[text] <= 0 then
            data.lore[text] = lume.copy(data._lore[text])
        end
        text = lume.eliminate(data.lore[text])
    end
    
    return text
end

data._lore = {

food_help = {
[[Note 63
It seems that the pigs can be tamed with carrots
and meat...
I wonder what else could be controlled?]],
[[The wildife seem to easily be captivated by
my food.]],
[[These pigs won't stop watching me whenever
I take a bite of any of my food! Anabelle!! Help!
]],
[[Not all of the monsters here seem to want to fight,
but a lot of them seem to dislike only adventurers...
Could it be because of the Statue?]],
[[Finally, some good food!!]],
[[When I eat I feel healthier, but too bad some stuff
spoils way too fast for me.]],
[[I roasted a carrot on the campfire we found, next
is just to find some meat.]],
},

general = {
[[The ... has the madness. It made the orb. Destroy at all costs. Run or ... will kill you. The ... isn't a Lich. There's also a--...]],
[[Note 94
The darkness corrupts, the madness. Unspeakable.
I need to get out. I need to tell them.]],
[[Note 187
The heart of a kobold, the soul of a dragon, and the
curse of an angel. This army, surely they will succeed.]],
[[Note 108
I need to something to help me escape. Allies, strong ones.
Reliable ones like Anabel...no. Ones that cannot die.]],
[[Note 152
Angel flesh tastes very sour, like a lemon. Or that may just
be my tongue burning off...? No matter, I can make another one.]],
[[Note 190
No matter, I can make another one.]],
[[Note 245
Looking through my journal, it seems I once went by the
title Edwin.
What a drab name.]],
[[Note 998
As I watched my carcass rot, I told myself, just one more go.]],
[[Who put these potions here, and why?]],
},

general_help = {
[[Note 21
Some of my potions seemed to boil and transfigure to have a
different effect.]],
[[Throwing potions of teleportation, that's how they travelled
through the vast dungeons and intertwined labyrinths.]],
[[The water collected in these bottles gleams so clearly in
the glass.]],
[[These beetles that resembleth rhinos, they seem to move in a straight line only turning once they bump into something or someone...strange.]],
[[Die to their bad eyesight, Juggernaut Beetles don't stop charging along a path, only turning once they bumb into something else.]]
},

goblin = {
[[Note 13
They seemed to gain comfort from the
camp fire. Occasionally they would throw
meat into it, displaying some sort of
intelligence. If they know how to cook,
what else might they be capable of doing?]],
[[We were pals, all four of us.
Until it ate the other 2. It can't be tamed.
I should have known.]],
[[The goblins seem to know how to utilize fire
to cook their food for a better meal]],
[[Note 4
The green skin of the goblins, studied up close,
seems to ... rub off? Leaving an almost
human like skin tone. Could they...? No...
I continue my research]],
[[Their corpses surrounded me, I expected
goblins blood to be green or even blue, but it
made no matter. I was about to die anyway.]],
[[I once saw a goblin hunt a rat, the rat then
proceeded to convulse and eat the goblin whole.
No one believes me.]],
[[Goblins seemed to be at the top of the food chain
here so far. But orcs make quick work of them.]],
[[And behold, the dragon swooped down, burning all,
until it was killed by the goblins. Til this day
I cannot fathom how.]],
[[Pig meat, rat meat, slime meat. Goblins will eat
all kinds of protein. Even resorting to cannibalism
if possible.]],
[[The goblin cried. It was a sort of execution. The rest
of its tribe members throwing stones at it, until
its inevitable death. I was eventually coerced into
participating in the event, but I felt strongly against
it]],
[[The polymorphism should last for a while, so I accepted
the invitation into their warren. This would
allow me to gain further information on the lives of these
would be savages.]],
[[Note ????
Of course I would never make it alive. I underestimated
their intelligence. I underestimated their strength, and
ontop of it all I underestimated their chief.
Anabell, I...To die in this body, how p]],
[[I resisted the process of the stoning and tried to stop
the brutal activity. Not soon after was I rebuked by both
the executioners and the goblin being executed. They continued
their activity but some seemd more suspicious of my origins.]],
[[The manner of which these goblins hunt is crude.
They charge at a pig until they die or they feast.]],
[[I witnessed a room in which a goblin was
being force fed until it seemed like it was about to choke.
I was escorted out before I could see more, but the next day
a new tribe member, bigger and stronger than the rest, was
bullying and ordering everyone around. Could it be...?]],
[[They locked me in a room, I panicked for was I not
one of them now? Why the treatment? I was brought
corpses of rats and pigs and even their own species
and told to eat. Not me, the great adventurer Jerikk!
Stoop so low, never. They forced me anyway and I felt like I
was to die.]],
[[The forceful feeding went on for what felt like days...]],
[[I woke up feeling taller and stronger. Even better than my now perished old body. All of the goblins trembled before me, I was like their new king.]],
[[There seemed to be one goblin that was calmer and smarter than the rest. It wasn't as loyal to me as the others, and didn't tremble in fear at my coming. I should investigate him further, but for now let me enjoy my improved physique.]],
[[These goblins, they pillage and raid. If not
for the immorality it's quite fun I would say.]],
[[They brought some of the human women they found to me, 
weak, blood covered and sometimes unconscious...
I was a chief now, no? Why not, I had needs.]],
[[I defiled some of them, not caring what
happened to their bodies once I was finished.]],
[[NO! NO! NO! NO! This I recognized one of them!
Seeet sister!!! Anabell!! I..I
What have I been doing!!!!?]],

},

adventurer  = {
[[Edwin said he was here for his research and that's all,
it was left to my loving sister Anabell and me, the great
Jerikk to claim the magical orb for our kingdom.]],
[[Anabell says keeping a journal is foolish, but I ask her,
how does she intend for the kingdom to worship her deeds if
she didn't actually write her deeds.]],
[[Great fame shall come to me, the great Jerikk! All the women
from around the kingdom shall be smithen with me. I shall take
25 wives. Hahah. Anabell does not understand my noble passions.]],
[[I gave her some blank scrolls and a pen but she tucked them in
her pack with a laugh, and spoke of my silly countenance.]],
[[Cornered! I had already been seperated from Anabelle quite a
while ago, but I'm sure she would be okay. She is strong,
stronger than me.]],
[[I proceeded to drink the only thing I had on me,
a potion of polymorphism! Into a goblin of all things!
I was hoping for healing, but the enemy pack of goblins
seemed to leave me be, so it had still worked
out for the great Jerikk! I decided to follow them for
protection for now.]],
[[I'm writing here. I don't know what to write...Edwin if
you see this, I know you're still around, know that I've
always loved you. Jerikk, oh sweet brother. I know deep down
you have the potential to be great, if you see this brother,
with the orb being the only way we'll be allowed out, I know
you can do it, I know you'll find a way to survive. The...]],
[[The goblins, they surround me now. I was the foolish one,
Jerikk not you. Oh, my time seems to be up. I wish I c]],
[[Note 2
Once I said my farewells to Jerikk (that brute) and Anabell
(such a beautiful ... colleague) I took my concentrated
elixir of polymorphism. I titled my formula 'Goblin Mode'.
Time to infiltrate a tribe.
]],
[[Note 20
I always have a backup. I managed to escape the goblin tribe.
I read a scroll of fear and they all scattered, even
the new chief. I then made haste out of the warren. With
some notes on goblins gathered, it was time to shift focus.
Formula Orc Mode.]],
[[Note 22
A good number of monsters ignore me, but goblins always
get aggrivated on site. They are considerably weaker
now in my orc form.]],
[[Note 31
I have come to the conclusion that goblins may actually
be smarter than the orcs. The orcs, though less mischievous
and less likely to attack the unknown, live off
pillaging and sacking. Or maybe it's just the 
hate that drives them?]]

},

minatour = {
[[A...A Maze!! It's a maze! Anabell and I were now lost.
But...something else was here. Something different.]],
[[What a funny cow,
for without a doubt,
Cause Though you may laugh,
and fingers you have,
You still moo real loud.]],
[[After buil ..#^^%$023; Th
 efh minatour guard my jxj
 s..f h treasu sapjc kds
 sacred. Keep it sacred.]],

},

statue = {
[[Note 8
The evilness was captivating. The residents seemed
to fear and respect it. But not staying near it enough
to call it worship.]],
[[It was beautiful, I told Anabell so. She agreed. Time
seemed to move and stand still, both at once.
When we finally moved I was sure we had been staring
at the statue for hours.]],
[[An army of stone men. Could this be ... golems?
Anabell says they're too small and we're not deep
enough.]]
}
}

data.lore = lume.deepcopy(data._lore)